package ubz.model;

import ubz.persistence.DotazioneLoader;

public class CassiereUbz extends Cassiere {

	private Politiche politiche;

	public CassiereUbz(DotazioneLoader loader) {
		super(loader);

		this.politiche = loader.getPolitiche();
	}

	@Override
	protected int calcolaQuantitDiQuestoTaglio(Taglio t, int importo){
		 int quantitDiQuestoTaglio = super.calcolaQuantitDiQuestoTaglio(t, importo);
		 int maxErogabileSecondoPolitica = politiche.getQuantit(t);
		 quantitDiQuestoTaglio = Math.min(maxErogabileSecondoPolitica, quantitDiQuestoTaglio);
		 return quantitDiQuestoTaglio;
	}

}
